<template>
  <div v-loading="loading" class="box-contact">
    <ValidationObserver v-slot="{ handleSubmit }">
      <CForm
        v-loading="loading"
        class="form-2-col"
        @submit.prevent="handleSubmit(onSendContact)"
      >
        <div class="box-inner-form">
          <div class="row">
            <div class="col-12 col-lg-6">
              <ValidationProvider v-slot="{ errors }" rules="required">
                <CInput
                  v-model="name"
                  type="text"
                  placeholder="お名前"
                >
                  <template #prepend-content>
                    <font-awesome-icon :icon="['fas', 'user-alt']" class="form-icon" />
                  </template>
                  <template #invalid-feedback>
                    <div class="d-block invalid-feedback">
                      {{ errors[0] }}
                    </div>
                  </template>
                </CInput>
              </ValidationProvider>
            </div>

            <div class="col-12 col-lg-6">
              <CInput
                v-model="corporateName"
                type="text"
                placeholder="法人名"
              >
                <template #prepend-content>
                  <font-awesome-icon :icon="['fas', 'building']" class="form-icon" />
                </template>
              </CInput>
            </div>
          </div>

          <div class="row">
            <div class="col-12 col-lg-6">
              <CInput
                v-model="departmentName"
                type="text"
                placeholder="部署名"
              >
                <template #prepend-content>
                  <font-awesome-icon :icon="['fas', 'suitcase']" class="form-icon" />
                </template>
              </CInput>
            </div>

            <div class="col-12 col-lg-6">
              <CInput
                v-model="title"
                type="text"
                placeholder="役職名"
              >
                <template #prepend-content>
                  <font-awesome-icon :icon="['fas', 'heading']" class="form-icon" />
                </template>
              </CInput>
            </div>
          </div>

          <div class="row">
            <div class="col-12 col-lg-6">
              <ValidationProvider v-slot="{ errors }" rules="required">
                <CInput
                  v-model="address"
                  type="text"
                  placeholder="ご住所"
                >
                  <template #prepend-content>
                    <font-awesome-icon :icon="['fas', 'map-marker-alt']" class="form-icon" />
                  </template>
                  <template #invalid-feedback>
                    <div class="d-block invalid-feedback">
                      {{ errors[0] }}
                    </div>
                  </template>
                </CInput>
              </ValidationProvider>
            </div>

            <div class="col-12 col-lg-6">
              <ValidationProvider v-slot="{ errors }" rules="required">
                <CInput
                  v-model="phone"
                  type="text"
                  placeholder="電話番号"
                >
                  <template #prepend-content>
                    <font-awesome-icon :icon="['fas', 'phone']" class="form-icon" />
                  </template>
                  <template #invalid-feedback>
                    <div class="d-block invalid-feedback">
                      {{ errors[0] }}
                    </div>
                  </template>
                </CInput>
              </ValidationProvider>
            </div>
          </div>

          <div class="row">
            <div class="col-12 col-lg-6">
              <CInput
                v-model="fax"
                type="text"
                placeholder="FAX番号"
              >
                <template #prepend-content>
                  <font-awesome-icon :icon="['fas', 'fax']" class="form-icon" />
                </template>
              </CInput>
            </div>

            <div class="col-12 col-lg-6">
              <ValidationProvider v-slot="{ errors }" rules="required|email">
                <CInput
                  v-model="email"
                  type="text"
                  placeholder="メールアドレス"
                >
                  <template #prepend-content>
                    <font-awesome-icon :icon="['fas', 'envelope']" class="form-icon" />
                  </template>
                  <template #invalid-feedback>
                    <div class="d-block invalid-feedback">
                      {{ errors[0] }}
                    </div>
                  </template>
                </CInput>
              </ValidationProvider>
            </div>
          </div>

          <div class="row">
            <div class="col-12">
              <ValidationProvider v-slot="{ errors }" rules="required">
                <CTextarea
                  v-model="content"
                  placeholder="お問合わせ内容"
                  rows="6"
                  class="custom-prepend-textarea"
                >
                  <template #prepend-content>
                    <font-awesome-icon :icon="['fas', 'sticky-note']" class="form-icon" />
                  </template>
                  <template #invalid-feedback>
                    <div class="d-block invalid-feedback">
                      {{ errors[0] }}
                    </div>
                  </template>
                </CTextarea>
              </ValidationProvider>
            </div>
          </div>

          <div class="box-action">
            <CButton
              type="submit"
              color="primary"
              size="lg"
            >
              <font-awesome-icon :icon="['fas', 'paper-plane']" class="form-icon" />
              確認画面へ
            </CButton>
          </div>
        </div>
      </CForm>
    </ValidationObserver>
  </div>
</template>

<style lang="scss" scoped>
  .box-contact {
    /deep/ {
      .input-group-prepend,
      .form-control {
        height: 55px;
      }
      .input-group-prepend {
        width: 55px;
      }
      .custom-prepend-textarea {
        .input-group-prepend,
        .form-control {
          height: auto;
        }
      }
      .form-control {
        border-color: #c9c9c9;
        border-radius: 0;
      }
      .input-group-text {
        width: 100%;
        justify-content: center;
        border-color: #c9c9c9;
        border-radius: 0;
      }
      .form-group {
        .form-icon {
          width: 16px;
          height: 16px;
        }
      }
      .box-action {
        text-align: center;
        margin-top: 40px;
        @include mq(max_md) {
          margin-top: 30px;
        }
        @include mq(max_sm) {
          margin-top: 20px;
        }
      }
    }
  }
</style>

<script>
export default {
  data () {
    return {
      // Form data
      name: null,
      corporateName: null,
      departmentName: null,
      title: null,
      address: null,
      phone: null,
      fax: null,
      email: null,
      content: null,

      // Other data
      loading: false
    }
  },

  computed: {
    /**
     * Get data on form
     *
     * @return {Object} Form data
     */
    formData () {
      const data = {}

      if (this.name) {
        data.name = this.name
      }

      if (this.corporateName) {
        data.corporate_name = this.corporateName
      }

      if (this.departmentName) {
        data.department_name = this.departmentName
      }

      if (this.title) {
        data.title = this.title
      }

      if (this.address) {
        data.address = this.address
      }

      if (this.phone) {
        data.phone = this.phone
      }

      if (this.fax) {
        data.fax = this.fax
      }

      if (this.email) {
        data.email = this.email
      }

      if (this.content) {
        data.content = this.content
      }

      return data
    }
  },

  methods: {
    /**
     * Call API to send contact
     */
    async onSendContact () {
      this.loading = true

      try {
        const res = await this.$dam.sendContact(this.formData)
        this.$debugger.log(res, 'xxx')

        this.$toast.success(
          this.$text.info('SENT')
        )

        this.loading = false
      } catch (err) {
        console.error(err)

        this.loading = false
        this.$toast.error(
          this.$text.error('FAILED_TO_SEND_CONTACT')
        )
      }
    }
  }
}
</script>
